def lunar_sum(a, b):
    """
    Выполняет сложение в лунной арифметике.
    """
    # Преобразуем числа в строки
    a, b = str(a), str(b)
    # Приводим строки к одинаковой длине, добавляя нули слева
    max_len = max(len(a), len(b))
    a, b = a.zfill(max_len), b.zfill(max_len)
    
    result = []
    for digit_a, digit_b in zip(a, b):
        result.append(str(max(int(digit_a), int(digit_b))))  # Максимум из цифр
    return int("".join(result))


def lunar_product(a, b):
    """
    Выполняет умножение в лунной арифметике.
    """
    # Преобразуем числа в строки
    a, b = str(a), str(b)
    # Приводим строки к одинаковой длине, добавляя нули слева
    max_len = max(len(a), len(b))
    a, b = a.zfill(max_len), b.zfill(max_len)
    
    result = []
    for digit_a, digit_b in zip(a, b):
        result.append(str(min(int(digit_a), int(digit_b))))  # Минимум из цифр
    return int("".join(result))


# Чтение данных
a = int(input("Введите число a: "))
b = int(input("Введите число b: "))

# Выполняем операции
sum_result = lunar_sum(a, b)
product_result = lunar_product(a, b)

# Выводим результат
print(sum_result)
print(product_result)
