from collections import defaultdict, deque

def solve():
    # Чтение входных данных
    n, m, k = map(int, input().split())  # количество складов, дорог и охраняемых складов
    guards = list(map(int, input().split()))  # номера охраняемых складов

    # Построение графа
    graph = defaultdict(list)
    for _ in range(m):
        u, v = map(int, input().split())
        graph[u].append(v)
        graph[v].append(u)

    # Массив для хранения минимального расстояния до ближайшего охраняемого склада
    distances = [-1] * (n + 1)
    queue = deque()

    # Инициализация BFS с охраняемых складов
    for guard in guards:
        queue.append(guard)
        distances[guard] = 0

    # BFS
    while queue:
        current = queue.popleft()
        for neighbor in graph[current]:
            if distances[neighbor] == -1:  # если склад ещё не посещён
                distances[neighbor] = distances[current] + 1
                queue.append(neighbor)

    # Определение охраняемых складов
    protected = [i for i in range(1, n + 1) if distances[i] != -1]

    # Вывод результата
    print(len(protected))
    print(*protected)

if __name__ == "__main__":
    solve()
